


#include <os.h>
#include "stringHelper.h"

inline void drawChar(unsigned char ch, int x, int y, char* scrbuf)
{
	// Copied from putChar, with slight modifications
	int i, j, pixelOn;
	for(i = 0; i < CHAR_HEIGHT; i++)  
	{
		for(j = 0; j < CHAR_WIDTH; j++) 
		{
			pixelOn = charMap_ascii[ch][i] << j;  
			pixelOn = pixelOn & 0x80;  
			if (pixelOn)
			{
				setPixelBuf(scrbuf, x + j, y + i, 0); 
			}
			else
			{
				// I want the text to not force a white background
				// setPixelBuf(scrbuf, x + j, y + i, 15);
			}
		}
	}
}

void drawString(unsigned char* str, int x, int y, char* scrbuf)
{
	int l = strlen(str);
	int i;
	for (i = 0; i < l; i++)
	{
		if (str[i] == 0x0A)
		{
			x = 0;
			y += 12;
		}
		else
		{
			drawChar(str[i], x, y, scrbuf);
		}
		x += 8;
		if (x >= 312)
		{
			x = 0;
			y += 12;
		}
	}
}